## xen 4.17.3+36

=== Makefile ===
#
# Grand Unified Makefile for Xen.
#

# Default target must appear before any include lines
.PHONY: all
all: dist

-include config/Toplevel.mk
SUBSYSTEMS?=xen tools stubdom docs
TARGS_DIST=$(patsubst %, dist-%, $(SUBSYSTEMS))
TARGS_INSTALL=$(patsubst %, install-%, $(SUBSYSTEMS))
TARGS_UNINSTALL=$(patsubst %, uninstall-%, $(SUBSYSTEMS))
TARGS_BUILD=$(patsubst %, build-%, $(SUBSYSTEMS))
TARGS_CLEAN=$(patsubst %, clean-%, $(SUBSYSTEMS))
TARGS_DISTCLEAN=$(patsubst %, distclean-%, $(SUBSYSTEMS))

export XEN_ROOT=$(CURDIR)
include Config.mk

.PHONY: mini-os-dir
mini-os-dir:
	if [ ! -d $(XEN_ROOT)/extras/mini-os ]; then \
		GIT=$(GIT) $(XEN_ROOT)/scripts/git-checkout.sh \
			$(MINIOS_UPSTREAM_URL) \
			$(MINIOS_UPSTREAM_REVISION) \
			$(XEN_ROOT)/extras/mini-os ; \
	fi

.PHONY: mini-os-dir-force-update
mini-os-dir-force-update: mini-os-dir
	set -ex; \
	if [ "$(MINIOS_UPSTREAM_REVISION)" ]; then \
		cd extras/mini-os-remote; \
		$(GIT) fetch origin; \
		$(GIT) reset --hard $(MINIOS_UPSTREAM_REVISION); \
	fi

export XEN_TARGET_ARCH
export DESTDIR

.PHONY: %-tools-public-headers
%-tools-public-headers:
	$(MAKE) -C tools/include $*

# build and install everything into the standard system directories
.PHONY: install
install: $(TARGS_INSTALL)

.PHONY: build
build: $(TARGS_BUILD)

.PHONY: build-xen
build-xen:
	$(MAKE) -C xen build

.PHONY: %_defconfig
%_defconfig:
	$(MAKE) -C xen $@

.PHONY: build-tools
build-tools: build-tools-public-headers
	$(MAKE) -C tools build

.PHONY: build-tools-oxenstored
build-tools-oxenstored: build-tools-public-headers
	$(MAKE) -s -C tools/ocaml clean
	$(MAKE) -s -C tools/libs
	$(MAKE) -C tools/ocaml build-tools-oxenstored

.PHONY: build-stubdom
build-stubdom: mini-os-dir build-tools-public-headers
	$(MAKE) -C stubdom build
ifeq (x86_64,$(XEN_TARGET_ARCH))
	XEN_TARGET_ARCH=x86_32 $(MAKE) -C stubdom pv-grub-if-enabled
endif

define do-subtree
$(1)/%: FORCE
	$$(MAKE) -C $(1) $$*
endef

$(foreach m,$(wildcard */Makefile),$(eval $(call do-subtree,$(patsubst %/Makefile,%,$(m)))))

.PHONY: build-docs
build-docs:
	$(MAKE) -C docs build

# The test target is for unit tests that can run without an installation.  Of
# course, many tests require a machine running Xen itself, and these are
# handled elsewhere.
.PHONY: test
test:
	$(MAKE) -C tools/python test

run-tests-%: build-tools-public-headers tools/tests/%/
	$(MAKE) -C tools/tests/$* run

# For most targets here,
#   make COMPONENT-TARGET
# is implemented, more or less, by
#   make -C COMPONENT TARGET
#
# Each rule that does this needs to have dependencies on any
# other COMPONENTs that have to be processed first.  See
# The install-tools target here for an example.
#
# dist* targets are special: these do not occur in lower-level
# Makefiles.  Instead, these are all implemented only here.
# They run the appropriate install targets with DESTDIR set.
#
# Also, we have a number of targets COMPONENT which run
# dist-COMPONENT, for convenience.
#
# The Makefiles invoked with -C from the toplevel should
# generally have the following targets:
#       all  build  install  clean  distclean


.PHONY: dist
dist: DESTDIR=$(DISTDIR)/install
dist: $(TARGS_DIST) dist-misc

dist-misc:
	$(INSTALL_DIR) $(DISTDIR)/
	$(INSTALL_DATA) ./COPYING $(DISTDIR)
	$(INSTALL_DATA) ./README $(DISTDIR)
	$(INSTALL_PROG) ./install.sh $(DISTDIR)


dist-%: DESTDIR=$(DISTDIR)/install
dist-%: install-%
	@: # do nothing

.PHONY: xen tools stubdom docs
xen: dist-xen
tools: dist-tools
stubdom: dist-stubdom
docs: dist-docs

.PHONY: install-xen
install-xen:
	$(MAKE) -C xen install

.PHONY: install-tools
install-tools: install-tools-public-headers
	$(MAKE) -C tools install

.PHONY: install-stubdom
install-stubdom: mini-os-dir install-tools
	$(MAKE) -C stubdom install
ifeq (x86_64,$(XEN_TARGET_ARCH))
	XEN_TARGET_ARCH=x86_32 $(MAKE) -C stubdom install-grub-if-enabled
endif

.PHONY: tools/firmware/seabios-dir-force-update
tools/firmware/seabios-dir-force-update:
	$(MAKE) -C tools/firmware seabios-dir-force-update

.PHONY: tools/firmware/ovmf-dir-force-update
tools/firmware/ovmf-dir-force-update:
	$(MAKE) -C tools/firmware ovmf-dir-force-update

.PHONY: install-docs
install-docs:
	$(MAKE) -C docs install

# We only have build-tests install-tests, not uninstall-tests etc.
.PHONY: build-tests
build-tests: build-xen
	$(MAKE) -C xen tests

.PHONY: install-tests
install-tests: install-xen
	$(MAKE) -C xen $@

# build xen and the tools and place them in the install
# directory. 'make install' should then copy them to the normal system
# directories
.PHONY: world
world: 
	$(MAKE) clean
	$(MAKE) dist

# Package a build in a debball file, that is inside a .deb format
# container to allow for easy and clean removal. This is not intended
# to be a full featured policy compliant .deb package.
.PHONY: debball
debball: dist
	fakeroot sh ./tools/misc/mkdeb $(XEN_ROOT) $$($(MAKE) -C xen xenversion --no-print-directory)

# Package a build in an rpmball file, that is inside a .rpm format
# container to allow for easy and clean removal. This is not intended
# to be a full featured policy compliant .rpm package.
.PHONY: rpmball
rpmball: dist
	bash ./tools/misc/mkrpm $(XEN_ROOT) $$($(MAKE) -C xen xenversion --no-print-directory)

.PHONY: subtree-force-update
subtree-force-update: mini-os-dir-force-update
	$(MAKE) -C tools subtree-force-update

.PHONY: subtree-force-update-all
subtree-force-update-all: mini-os-dir-force-update
	$(MAKE) -C tools subtree-force-update-all

# Make a source tarball, including qemu sub-trees.
#
# src-tarball will use "git describe" for the version number.  This
# will have the most recent tag, number of commits since that tag, and
# git commit id of the head.  This is suitable for a "snapshot"
# tarball of an unreleased tree.
#
# src-tarball-release will use "make xenversion" as the version
# number.  This is suitable for release tarballs.
.PHONY: src-tarball-release
src-tarball-release: subtree-force-update-all
	bash ./tools/misc/mktarball $(XEN_ROOT) $$($(MAKE) -C xen xenversion --no-print-directory)

.PHONY: src-tarball
src-tarball: subtree-force-update-all
	bash ./tools/misc/mktarball $(XEN_ROOT) $$(git describe)

.PHONY: clean
clean: $(TARGS_CLEAN)

.PHONY: clean-xen
clean-xen:
	$(MAKE) -C xen clean

.PHONY: clean-tools
clean-tools: clean-tools-public-headers
	$(MAKE) -C tools clean

.PHONY: clean-stubdom
clean-stubdom: clean-tools-public-headers
	$(MAKE) -C stubdom crossclean
ifeq (x86_64,$(XEN_TARGET_ARCH))
	XEN_TARGET_ARCH=x86_32 $(MAKE) -C stubdom crossclean
endif

.PHONY: clean-docs
clean-docs:
	$(MAKE) -C docs clean

# clean, but blow away tarballs
.PHONY: distclean
distclean: $(TARGS_DISTCLEAN)
	$(MAKE) -C tools/include distclean
	rm -f config/Toplevel.mk
	rm -rf dist
	rm -rf config.log config.status config.cache autom4te.cache

.PHONY: distclean-xen
distclean-xen:
	$(MAKE) -C xen distclean

.PHONY: distclean-tools
distclean-tools:
	$(MAKE) -C tools distclean

.PHONY: distclean-stubdom
distclean-stubdom:
	$(MAKE) -C stubdom distclean
ifeq (x86_64,$(XEN_TARGET_ARCH))
	XEN_TARGET_ARCH=x86_32 $(MAKE) -C stubdom distclean
endif
	rm -rf extras/mini-os extras/mini-os-remote

.PHONY: distclean-docs
distclean-docs:
	$(MAKE) -C docs distclean

# Linux name for GNU distclean
.PHONY: mrproper
mrproper: distclean

.PHONY: help
help:
	@echo 'Installation targets:'
	@echo '  install               - build and install everything'
	@echo '  install-xen           - build and install the Xen hypervisor'
	@echo '  install-tools         - build and install the control tools'
	@echo '  install-stubdom       - build and install the stubdomain images'
	@echo '  install-docs          - build and install user documentation'
	@echo ''
	@echo 'Local dist targets:'
	@echo '  dist                  - build and install everything into local dist directory'
	@echo '  world                 - clean everything then make dist'
	@echo '  dist-xen              - build Xen hypervisor and install into local dist'
	@echo '  dist-tools            - build the tools and install into local dist'
	@echo '  dist-stubdom          - build the stubdomain images and install into local dist'
	@echo '  dist-docs             - build user documentation and install into local dist'
	@echo ''
	@echo 'Building targets:'
	@echo '  build                 - build everything'
	@echo '  build-xen             - build Xen hypervisor'
	@echo '  build-tools           - build the tools'
	@echo '  build-stubdom         - build the stubdomain images'
	@echo '  build-docs            - build user documentation'
	@echo ''
	@echo 'Cleaning targets:'
	@echo '  clean                 - clean the Xen, tools and docs'
	@echo '  distclean             - clean plus delete kernel build trees and'
	@echo '                          local downloaded files'
	@echo '  subtree-force-update  - Call *-force-update on all git subtrees (qemu, seabios, ovmf)'
	@echo ''
	@echo 'Miscellaneous targets:'
	@echo '  uninstall             - attempt to remove installed Xen tools'
	@echo '                          (use with extreme care!)'
	@echo
	@echo 'Package targets:'
	@echo '  src-tarball-release   - make a source tarball with xen and qemu tagged with a release'
	@echo '  src-tarball           - make a source tarball with xen and qemu tagged with git describe'
	@echo
	@echo 'Environment:'
	@echo '  [ this documentation is sadly not complete ]'

# Use this target with extreme care!

.PHONY: uninstall-xen
uninstall-xen:
	$(MAKE) -C xen uninstall

.PHONY: uninstall-tools
uninstall-tools:
	$(MAKE) -C tools uninstall

.PHONY: uninstall-stubdom
uninstall-stubdom:
	$(MAKE) -C stubdom uninstall

.PHONY: uninstall-docs
uninstall-docs:
	$(MAKE) -C docs uninstall

.PHONY: uninstall
uninstall: D=$(DESTDIR)
uninstall: uninstall-tools-public-headers $(TARGS_UNINSTALL)

.PHONY: xenversion
xenversion:
	@$(MAKE) --no-print-directory -C xen xenversion

.PHONY: FORCE
FORCE:

=== xen/Makefile ===
# $(lastword,) for GNU Make older than 3.81
lastword = $(word $(words $(1)),$(1))
this-makefile := $(call lastword,$(MAKEFILE_LIST))

# This is the correct place to edit the build version.
# All other places this is stored (eg. compile.h) should be autogenerated.
export XEN_VERSION       = 4
export XEN_SUBVERSION    = 17
export XEN_EXTRAVERSION ?= .4-pre$(XEN_VENDORVERSION)
export XEN_FULLVERSION   = $(XEN_VERSION).$(XEN_SUBVERSION)$(XEN_EXTRAVERSION)
-include xen-version

export XEN_WHOAMI	?= $(USER)
ifeq ($(origin XEN_DOMAIN), undefined)
export XEN_DOMAIN	:= $(shell ([ -x /bin/dnsdomainname ] && /bin/dnsdomainname) || ([ -x /bin/domainname ] && /bin/domainname || echo [unknown]))
endif
ifeq ($(origin XEN_BUILD_DATE), undefined)
export XEN_BUILD_DATE	:= $(shell LC_ALL=C date)
endif
ifeq ($(origin XEN_BUILD_TIME), undefined)
export XEN_BUILD_TIME	:= $(shell LC_ALL=C date +%T)
endif
ifeq ($(origin XEN_BUILD_HOST), undefined)
export XEN_BUILD_HOST	:= $(shell hostname)
endif

# Best effort attempt to find a python interpreter, defaulting to Python 3 if
# available.  Fall back to just `python`.
PYTHON_INTERPRETER	:= $(word 1,$(shell command -v python3 || command -v python || command -v python2) python)
export PYTHON		?= $(PYTHON_INTERPRETER)

export CHECKPOLICY	?= checkpolicy

$(if $(filter __%, $(MAKECMDGOALS)), \
    $(error targets prefixed with '__' are only for internal use))

# That's our default target when none is given on the command line
PHONY := __all
__all:

# Do not use make's built-in rules and variables
MAKEFLAGS += -rR

EFI_MOUNTPOINT ?= $(BOOT_DIR)/efi

# Allow someone to change their config file
export KCONFIG_CONFIG ?= .config

export TARGET := xen

.PHONY: dist
dist: install

ifneq ($(root-make-done),y)
# section to run before calling Rules.mk, but only once.

ifneq ($(origin crash_debug),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable crash_debug now.")
endif
ifeq ($(origin debug),command line)
$(warning "You must use e.g. 'make menuconfig' to enable/disable debug now.")
endif
ifneq ($(origin frame_pointer),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable frame_pointer now.")
endif
ifneq ($(origin kexec),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable kexec now.")
endif
ifneq ($(origin lock_profile),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable lock_profile now.")
endif
ifneq ($(origin perfc),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable perfc now.")
endif
ifneq ($(origin verbose),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable verbose now.")
endif

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing will be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.
#
# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE := $(V)
endif
ifndef KBUILD_VERBOSE
    KBUILD_VERBOSE := 0
endif

ifeq ($(KBUILD_VERBOSE),1)
    quiet :=
    Q :=
else
    quiet := quiet_
    Q := @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(filter-out --%,$(MAKEFLAGS))),)
    quiet := silent_
endif

export quiet Q KBUILD_VERBOSE

# $(realpath,) for GNU Make older than 3.81
realpath = $(wildcard $(foreach file,$(1),$(shell cd -P $(dir $(file)) && echo "$$PWD/$(notdir $(file))")))

ifeq ("$(origin O)", "command line")
    KBUILD_OUTPUT := $(O)
endif

ifneq ($(KBUILD_OUTPUT),)
# Make's built-in functions such as $(abspath ...), $(realpath ...) cannot
# expand a shell special character '~'. We use a somewhat tedious way here.
abs_objtree := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) && pwd)
$(if $(abs_objtree),, \
     $(error failed to create output directory "$(KBUILD_OUTPUT)"))

# $(realpath ...) resolves symlinks
abs_objtree := $(call realpath,$(abs_objtree))
else
abs_objtree := $(CURDIR)
endif

ifeq ($(abs_objtree),$(CURDIR))
# Suppress "Entering directory ..." unless we are changing the work directory.
MAKEFLAGS += --no-print-directory
else
need-sub-make := 1
endif

abs_srctree := $(call realpath,$(dir $(this-makefile)))

ifneq ($(words $(subst :, ,$(abs_srctree))), 1)
$(error source directory cannot contain spaces or colons)
endif

ifneq ($(abs_srctree),$(abs_objtree))
# Look for make include files relative to root of kernel src
#
# This does not become effective immediately because MAKEFLAGS is re-parsed
# once after the Makefile is read. We need to invoke sub-make.
MAKEFLAGS += --include-dir=$(abs_srctree)
need-sub-make := 1
endif

export abs_srctree abs_objtree
export root-make-done := y

ifeq ($(need-sub-make),1)

PHONY += $(MAKECMDGOALS) __sub-make

$(filter-out $(this-makefile), $(MAKECMDGOALS)) __all: __sub-make
	@:

# Invoke a second make in the output directory, passing relevant variables
__sub-make:
	$(Q)$(MAKE) -C $(abs_objtree) -f $(abs_srctree)/Makefile $(MAKECMDGOALS)

endif # need-sub-make
endif # root-make-done

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(need-sub-make),)

# Do not print "Entering directory ...",
# but we want to display it when entering to the output directory
# so that IDEs/editors are able to understand relative filenames.
MAKEFLAGS += --no-print-directory

ifeq ($(abs_srctree),$(abs_objtree))
    # building in the source tree
    srctree := .
    building_out_of_srctree :=
else
    ifeq ($(abs_srctree)/,$(dir $(abs_objtree)))
        # building in a subdirectory of the source tree
        srctree := ..
    else
        srctree := $(abs_srctree)
    endif
    building_out_of_srctree := 1
endif

objtree := .
VPATH := $(srctree)

export building_out_of_srctree srctree objtree VPATH

export XEN_ROOT := $(abs_srctree)/..

# To make sure we do not include .config for any of the *config targets
# catch them early, and hand them over to tools/kconfig/Makefile

clean-targets := %clean
no-dot-config-targets := $(clean-targets) \
                         uninstall debug cloc \
                         cscope TAGS tags gtags \
                         xenversion

config-build    := n
need-config     := y

ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
    ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
        need-config := n
    endif
endif

ifneq ($(filter %config,$(MAKECMDGOALS)),)
    config-build := y
endif

include scripts/Kbuild.include

# Don't break if the build process wasn't called from the top level
# we need XEN_TARGET_ARCH to generate the proper config
include $(XEN_ROOT)/Config.mk

# Set ARCH/SRCARCH appropriately.

ARCH := $(XEN_TARGET_ARCH)
SRCARCH := $(shell echo $(ARCH) | \
    sed -e 's/x86.*/x86/' -e 's/arm\(32\|64\)/arm/g' \
        -e 's/riscv.*/riscv/g')
export ARCH SRCARCH

export CONFIG_SHELL := $(SHELL)
export CC CXX LD NM OBJCOPY OBJDUMP ADDR2LINE
export YACC = $(if $(BISON),$(BISON),bison)
export LEX = $(if $(FLEX),$(FLEX),flex)

# Default file for 'make defconfig'.
export KBUILD_DEFCONFIG := $(ARCH)_defconfig

# Copy CFLAGS generated by "Config.mk" so they can be reused later without
# reparsing Config.mk by e.g. arch/x86/boot/.
export XEN_TREEWIDE_CFLAGS := $(CFLAGS)

# CLANG_FLAGS needs to be calculated before calling Kconfig
ifneq ($(shell $(CC) --version 2>&1 | head -n 1 | grep clang),)
CLANG_FLAGS :=

ifeq ($(SRCARCH),x86)
# The tests to select whether the integrated assembler is usable need to happen
# before testing any assembler features, or else the result of the tests would
# be stale if the integrated assembler is not used.

# Older clang's built-in assembler doesn't understand .skip with labels:
# https://bugs.llvm.org/show_bug.cgi?id=27369
t1 = $(call as-insn,$(CC),".L0: .L1: .skip (.L1 - .L0)",,-no-integrated-as)

# Check whether clang asm()-s support .include.
t2 = $(call as-insn,$(CC) -I$(srctree)/arch/x86/include,".include \"asm/asm-defns.h\"",,-no-integrated-as)

# Check whether clang keeps .macro-s between asm()-s:
# https://bugs.llvm.org/show_bug.cgi?id=36110
t3 = $(call as-insn,$(CC),".macro FOO;.endm"$(close); asm volatile $(open)".macro FOO;.endm",-no-integrated-as)

CLANG_FLAGS += $(call or,$(t1),$(t2),$(t3))
endif

CLANG_FLAGS += -Werror=unknown-warning-option
CFLAGS += $(CLANG_FLAGS)
export CLANG_FLAGS
endif

export XEN_HAS_CHECKPOLICY := $(call success,$(CHECKPOLICY) -h 2>&1 | grep -q xen)

# ===========================================================================
# Rules shared between *config targets and build targets

PHONY += tools_fixdep
tools_fixdep:
	$(Q)$(MAKE) $(build)=tools tools/fixdep

PHONY += outputmakefile
# Before starting out-of-tree build, make sure the source tree is clean.
# outputmakefile generates a Makefile in the output directory, if using a
# separate output directory. This allows convenient use of make in the
# output directory.
# At the same time when output Makefile generated, generate .gitignore to
# ignore whole output directory

quiet_cmd_makefile = GEN     Makefile
cmd_makefile = { \
    echo "\# Automatically generated by $(srctree)/Makefile: don't edit"; \
    echo "include $(srctree)/Makefile"; \
    } > Makefile

outputmakefile:
	$(Q)ln -fsn $(srctree) source
ifdef building_out_of_srctree
	$(Q)if [ -f $(srctree)/.config -o \
		 -d $(srctree)/include/config -o \
		 -d $(srctree)/include/generated ]; then \
		echo >&2 "***"; \
		echo >&2 "*** The source tree is not clean, please run 'make$(if $(findstring command line, $(origin XEN_TARGET_ARCH)), XEN_TARGET_ARCH=$(XEN_TARGET_ARCH)) distclean'"; \
		echo >&2 "*** in $(abs_srctree)";\
		echo >&2 "***"; \
		false; \
	fi
	$(call cmd,makefile)
	$(Q)test -e .gitignore || \
	{ echo "# this is build directory, ignore it"; echo "*"; } > .gitignore
endif

ifeq ($(config-build),y)
# ===========================================================================
# *config targets only - make sure prerequisites are updated, and descend
# in tools/kconfig to make the *config target

# Create a file for KCONFIG_ALLCONFIG which depends on the environment.
# This will be use by kconfig targets allyesconfig/allmodconfig/allnoconfig/randconfig
filechk_kconfig_allconfig = \
    $(if $(findstring n,$(XEN_HAS_CHECKPOLICY)), echo 'CONFIG_XSM_FLASK_POLICY=n';) \
    $(if $(KCONFIG_ALLCONFIG), cat $(KCONFIG_ALLCONFIG);) \
    :

.allconfig.tmp: FORCE
	set -e; { $(call filechk_kconfig_allconfig); } > $@

config: tools_fixdep outputmakefile FORCE
	$(Q)$(MAKE) $(build)=tools/kconfig $@

# Config.mk tries to include .config file, don't try to remake it
%/.config: ;

%config: .allconfig.tmp tools_fixdep outputmakefile FORCE
	$(Q)$(MAKE) $(build)=tools/kconfig KCONFIG_ALLCONFIG=$< $@

else # !config-build

ifeq ($(need-config),y)
-include include/config/auto.conf
# Read in dependencies to all Kconfig* files, make sure to run syncconfig if
# changes are detected.
-include include/config/auto.conf.cmd

# Allow people to just run `make` as before and not force them to configure
# Only run defconfig if $(KCONFIG_CONFIG) is missing
$(KCONFIG_CONFIG): tools_fixdep
	$(if $(wildcard $@), , $(Q)$(MAKE) $(build)=tools/kconfig defconfig)

=== stubdom/grub/Makefile ===
XEN_ROOT = $(CURDIR)/../..

include $(XEN_ROOT)/Config.mk
vpath %.c ../grub-upstream

BOOT=$(OBJ_DIR)/boot-$(XEN_TARGET_ARCH).o

DEF_CPPFLAGS += -I$(XEN_ROOT)/tools/libs/toollog/include
DEF_CPPFLAGS += -I$(XEN_ROOT)/tools/libs/ctrl/include
DEF_CPPFLAGS += -I$(XEN_ROOT)/tools/libs/guest/include
DEF_CPPFLAGS += -I$(XEN_ROOT)/tools/include -I.
DEF_CPPFLAGS += -I../grub-upstream/stage1
DEF_CPPFLAGS += -I../grub-upstream/stage2
DEF_CPPFLAGS += -I../grub-upstream/netboot
DEF_CPPFLAGS += -I$(XEN_ROOT)/tools/firmware/vgabios
DEF_CPPFLAGS += -DWITHOUT_LIBC_STUBS
DEF_CPPFLAGS += -DSUPPORT_NETBOOT
DEF_CPPFLAGS += -DSUPPORT_GRAPHICS
DEF_CPPFLAGS += -DSUPPORT_SERIAL
DEF_CPPFLAGS += -DPRESET_MENU_STRING='""'
DEF_CPPFLAGS += -DPACKAGE='"grubdom"' -DVERSION='"0.97"'

all: $(OBJ_DIR)/main.a

STAGE2_SOURCES=builtins.c char_io.c cmdline.c common.c console.c disk_io.c graphics.c gunzip.c md5.c serial.c stage2.c terminfo.c tparm.c

NETBOOT_SOURCES=fsys_tftp.c main.c misc.c
CPPFLAGS += -DFSYS_TFTP=1

STAGE2_SOURCES+=fsys_ext2fs.c
CPPFLAGS += -DFSYS_EXT2FS=1

STAGE2_SOURCES+=fsys_fat.c
CPPFLAGS += -DFSYS_FAT=1

STAGE2_SOURCES+=fsys_ffs.c
CPPFLAGS += -DFSYS_FFS=1

STAGE2_SOURCES+=fsys_iso9660.c
CPPFLAGS += -DFSYS_ISO9660=1

STAGE2_SOURCES+=fsys_jfs.c
CPPFLAGS += -DFSYS_JFS=1

STAGE2_SOURCES+=fsys_minix.c
CPPFLAGS += -DFSYS_MINIX=1

STAGE2_SOURCES+=fsys_reiserfs.c
CPPFLAGS += -DFSYS_REISERFS=1

STAGE2_SOURCES+=fsys_ufs2.c
CPPFLAGS += -DFSYS_UFS2=1

STAGE2_SOURCES+=fsys_vstafs.c
CPPFLAGS += -DFSYS_VSTAFS=1

STAGE2_SOURCES+=fsys_xfs.c
CPPFLAGS += -DFSYS_XFS=1

STAGE2_SOURCES:=$(addprefix stage2/,$(STAGE2_SOURCES))
NETBOOT_SOURCES:=$(addprefix netboot/,$(NETBOOT_SOURCES))

$(BOOT): DEF_CPPFLAGS+=-D__ASSEMBLY__

PV_GRUB_SOURCES = kexec.c mini-os.c
PV_GRUB_SOURCES += ../polarssl-$(XEN_TARGET_ARCH)/library/sha1.o

SOURCES = $(NETBOOT_SOURCES) $(STAGE2_SOURCES) $(PV_GRUB_SOURCES)

OBJS = $(addprefix $(OBJ_DIR)/,$(SOURCES:.c=.o))

$(OBJ_DIR)/dirs:
	mkdir -p $(OBJ_DIR)/netboot $(OBJ_DIR)/stage2
	touch $@

$(OBJS): $(OBJ_DIR)/dirs

$(OBJ_DIR)/main.a: $(BOOT) $(OBJS)
	$(AR) cr $@ $^

$(OBJ_DIR)/%.o: %.c
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@

$(OBJ_DIR)/%.o: %.S
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@

clean:
	rm -fr dirs *.a *.o stage2 netboot

=== tools/libs/vchan/Makefile ===
XEN_ROOT = $(CURDIR)/../../..
include $(XEN_ROOT)/tools/Rules.mk

CFLAGS += $(CFLAGS_libxenctrl)

LIBHEADER := libxenvchan.h

OBJS-y += init.o
OBJS-y += io.o

NO_HEADERS_CHK := y

include $(XEN_ROOT)/tools/libs/libs.mk

clean::
	rm -f libxenvchan.map

=== tools/tests/xenstore/Makefile ===
XEN_ROOT=$(CURDIR)/../../..
include $(XEN_ROOT)/tools/Rules.mk

TARGETS-y := test-xenstore
TARGETS := $(TARGETS-y)

.PHONY: all
all: build

.PHONY: build
build: $(TARGETS)

.PHONY: clean
clean:
	$(RM) -- *.o $(TARGETS) $(DEPS_RM)

.PHONY: distclean
distclean: clean
	$(RM) -- *~

.PHONY: install
install: all
	$(INSTALL_DIR) $(DESTDIR)$(LIBEXEC_BIN)
	$(if $(TARGETS),$(INSTALL_PROG) $(TARGETS) $(DESTDIR)$(LIBEXEC_BIN))

.PHONY: uninstall
uninstall:
	$(RM) -- $(addprefix $(DESTDIR)$(LIBEXEC_BIN)/,$(TARGETS))

CFLAGS += $(CFLAGS_libxenstore)
CFLAGS += $(APPEND_CFLAGS)

LDFLAGS += $(LDLIBS_libxenstore)
LDFLAGS += $(APPEND_LDFLAGS)
ifeq ($(CONFIG_Linux),y)
LDFLAGS += -Wl,--as-needed -lc -lrt
endif

%.o: Makefile

test-xenstore: test-xenstore.o
	$(CC) -o $@ $< $(LDFLAGS)

-include $(DEPS_INCLUDE)

=== xen/arch/arm/arm64/Makefile ===
obj-y += lib/

obj-y += cache.o
obj-y += cpufeature.o
obj-$(CONFIG_HARDEN_BRANCH_PREDICTOR) += bpi.o
obj-$(CONFIG_EARLY_PRINTK) += debug.o
obj-y += domctl.o
obj-y += domain.o
obj-y += entry.o
obj-y += head.o
obj-y += insn.o
obj-$(CONFIG_LIVEPATCH) += livepatch.o
obj-y += smc.o
obj-y += smpboot.o
obj-y += traps.o
obj-y += vfp.o
obj-y += vsysreg.o

## xen 4.17.3+36-g54dacb5c02

=== debian/changelog ===
xen (4.17.3+36-g54dacb5c02-1) unstable; urgency=medium

  * Update to new upstream version 4.17.3+36-g54dacb5c02, which also contains
    security fixes for the following issues:
    - x86: shadow stack vs exceptions from emulation stubs
      XSA-451 CVE-2023-46841
  * Properly incorporate NMU changes.
  * Pick upstream commit b33a5c5929 ("tools/xenstore/xenstored_control.c:
    correctly print time_t") to fix a FTBFS on armhf with 64 bits time_t.
    (Closes: #1065794)

 -- Hans van Kranenburg <hans@knorrie.org>  Sat, 09 Mar 2024 22:03:11 +0100

xen (4.17.3+10-g091466ba55-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063270

 -- Steve Langasek <vorlon@debian.org>  Thu, 29 Feb 2024 07:08:41 +0000

=== debian/control ===
Source: xen
Priority: optional
Maintainer: Debian Xen Team <pkg-xen-devel@lists.alioth.debian.org>
Uploaders: Ian Jackson <iwj@xenproject.org>, Hans van Kranenburg <hans@knorrie.org>
Section: admin
Standards-Version: 4.6.2
Build-Depends:
   debhelper-compat (= 13),
   dh-exec,
   dpkg-dev (>= 1.22.5),
   file,
   rdfind,
   lsb-release,
   flex, bison,
   python3-dev:any,
   libpython3-dev,
   dh-python,
   bcc [amd64],
   gcc-multilib [amd64],
   libext2fs-dev,
   iasl,
   seabios (>= 1.7.4-2~) [amd64],
   libaio-dev,
   libfdt-dev [armhf arm64],
   libglib2.0-dev,
   liblzma-dev,
   libncurses-dev,
   libpixman-1-dev,
   libyajl-dev,
   pkg-config,
   uuid-dev,
   zlib1g-dev,
   libzstd-dev,
   pandoc,
   ocaml,
   ocaml-findlib,
Homepage: https://xenproject.org/
Vcs-Browser: https://salsa.debian.org/xen-team/debian-xen
Vcs-Git: https://salsa.debian.org/xen-team/debian-xen.git
Rules-Requires-Root: no

Package: xenstore-utils
Architecture: amd64 arm64 armhf
Section: admin
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: xen-utils-common (<= 4.11.1~pre+1.733450b39b-1~)
Breaks: xen-utils-common (<= 4.11.1~pre+1.733450b39b-1~)
Suggests: xen-doc
Description: Xenstore command line utilities for Xen
 This package contains command line utilities for interacting with
 XenStore.
 .
 XenStore is a shared database used for interdomain communication of
 configuration and status information.  It is accessible to all domains
 running on the same Xen host.  See https://wiki.xen.org/wiki/XenStore for
 more information.
 .
 In the common case these tools are used by the Xen toolstack running in
 domain0 (or a driver domain) however they may also be used in a guest
 domain to support local scripting which wants to communicate via XenStore.

Package: xen-utils-common
Section: admin
Architecture: amd64 armhf arm64
Depends: sysvinit-utils (>= 3.05-4~) | lsb-base, udev, xenstore-utils,
    ${shlibs:Depends}, ${python3:Depends}, ${misc:Depends}
# The "| lsb-base" is needed for backporting to bullseye. It can be removed
# once backporting to bullseye is no longer needed.
Suggests: xen-doc
Description: Xen administrative tools - common files
 The userspace tools to manage a system virtualized through the Xen virtual
 machine monitor.
 .
 This package is only required on the host system (Domain 0) and not on the
 virtual guest systems (Domain U).

Package: xen-hypervisor-common
Section: kernel
Architecture: amd64 armhf arm64
Depends: ${misc:Depends}
Replaces: xen-hypervisor-4.8-amd64, xen-hypervisor-4.8-arm64, xen-hypervisor-4.8-armhf
Description: Xen Hypervisor - common files
 The configuration which arranges for an installed hypervisor to be booted
 as default, with the right command line arguments passed to both
 hypervisor and host (Domain 0) kernel.
 .
 This package is only required on the host system (Domain 0) and not on the
 virtual guest systems (Domain U).

Package: xen-doc
Section: doc
Architecture: amd64 armhf arm64
Depends: ${misc:Depends}
Description: Xen documentation
 Documentation for the Xen hypervisor and surrounding software,
 including descriptions of the hypercall interfaces and of some
 of the library APIs.
 .
 You do not need this package for the primary manpages for the
 Xen control utilities, as those are in the xen-utils-common package.
# Yes, arch-specific.  See xen-doc.lintian-overrides.

Package: xen-utils-4.17
Section: admin
Architecture: amd64 arm64 armhf
Provides: xen-utils
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, xen-utils-common (>= ${source:Version})
Recommends: bridge-utils, xen-hypervisor-4.17, qemu-system-xen (>> 1:7.0+dfsg-6~) [amd64], grub-xen-host [amd64]
Suggests: qemu-utils [amd64], seabios [amd64], ovmf
Description: Xen administrative tools
 The userspace tools to manage a system virtualized through the Xen virtual
 machine monitor.
 .
 qemu-utils and seabios are needed for "Xen HVM" (amd64)
Built-Using: ${misc:Built-Using}

Package: xen-utils-4.17-dbg
Section: debug
Architecture: amd64 arm64 armhf
Priority: optional
Depends: xen-utils-4.17 (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for xen-utils-4.17
 This package provides debug symbols for the xen-utils binaries as well as
 detached debug symbols for the `shim' used for booting PV guests in an HVM
 container.

Package: xen-hypervisor-4.17-amd64
Section: kernel
Architecture: amd64
Provides: xen-hypervisor, xen-hypervisor-4.17, xen-hypervisor-amd64
Depends: ${misc:Depends}
Recommends: xen-utils-4.17, xen-hypervisor-common
Description: Xen Hypervisor on AMD64
 The hypervisor is the "core" for Xen itself.  It gets started by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.

Package: xen-hypervisor-4.17-amd64-dbg
Section: debug
Architecture: amd64
Priority: optional
Depends: xen-hypervisor-4.17-amd64 (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for Xen Hypervisor on AMD64
 This package provides the detached debug symbols for the Xen hypervisor.

Package: xen-system-amd64
Section: admin
Architecture: amd64
Provides: xen-system
Depends: xen-hypervisor-4.17-amd64, xen-hypervisor-common, xen-utils-4.17, ${misc:Depends}
Description: Xen System on AMD64 (metapackage)
 This package depends on the latest Xen hypervisor for use on AMD64 and the
 Xen utils.

Package: xen-hypervisor-4.17-arm64
Section: kernel
Architecture: arm64
Provides: xen-hypervisor, xen-hypervisor-4.17, xen-hypervisor-arm64
Depends: ${misc:Depends}
Recommends: xen-utils-4.17, xen-hypervisor-common
Description: Xen Hypervisor on ARM64
 The hypervisor is the "core" for Xen itself.  It gets started by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.

Package: xen-hypervisor-4.17-arm64-dbg
Section: debug
Architecture: arm64
Priority: optional
Depends: xen-hypervisor-4.17-arm64 (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for Xen Hypervisor on ARM64
 This package provides the detached debug symbols for the Xen hypervisor.

Package: xen-system-arm64
Section: admin
Architecture: arm64
Provides: xen-system
Depends: xen-hypervisor-4.17-arm64, xen-hypervisor-common, xen-utils-4.17, ${misc:Depends}
Description: Xen System on ARM64 (metapackage)
 This package depends on the latest Xen hypervisor for use on ARM64 and the
 Xen utils.

Package: xen-hypervisor-4.17-armhf
Section: kernel
Architecture: armhf
Provides: xen-hypervisor, xen-hypervisor-4.17, xen-hypervisor-armhf
Depends: ${misc:Depends}
Recommends: xen-utils-4.17, xen-hypervisor-common
Description: Xen Hypervisor on ARMHF
 The hypervisor is the "core" for Xen itself.  It gets started by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.

Package: xen-hypervisor-4.17-armhf-dbg
Section: debug
Architecture: armhf
Priority: optional
Depends: xen-hypervisor-4.17-armhf (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for Xen Hypervisor on ARMHF
 This package provides the detached debug symbols for the Xen hypervisor.

Package: xen-system-armhf
Section: admin
Architecture: armhf
Provides: xen-system
Depends: xen-hypervisor-4.17-armhf, xen-hypervisor-common, xen-utils-4.17, ${misc:Depends}
Description: Xen System on ARMHF (metapackage)
 This package depends on the latest Xen hypervisor for use on ARMHF and the
 Xen utils.

Package: libxen-dev
Section: libdevel
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends},
	 libxenmisc4.17t64 (= ${binary:Version}),
	 libxencall1t64 (= ${binary:Version}),
	 libxendevicemodel1t64 (= ${binary:Version}),
	 libxenevtchn1t64 (= ${binary:Version}),
	 libxenforeignmemory1t64 (= ${binary:Version}),
	 libxengnttab1t64 (= ${binary:Version}),
	 libxenstore4t64 (= ${binary:Version}),
	 libxentoolcore1t64 (= ${binary:Version}),
	 libxentoollog1t64 (= ${binary:Version}),
	 libxenhypfs1t64 (= ${binary:Version}),
Description: Public headers and libs for Xen
 This package contains the public headers and static libraries for Xen.
 .
 The libxenlight library is intended as a common base for all Xen toolstack
 developers.  The libxlutil library contains additional helpers which may
 be useful to toolstack developers.
 .
 The libxenstore library allows userspace processes to interact with
 the XenStore database.  Command line tools for accessing xenstore are
 provided is via the xenstore-utils package.
 .
 Most of the other included libraries are internal, and intended for
 use by the Xen toolstack, rather than directly.

Package: libxenmisc4.17t64
Provides: ${t64:Provides}
Replaces: libxenmisc4.17
Breaks: libxenmisc4.17 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - miscellaneous, versioned ABI
 Shared libraries for Xen utilities.
 This package contains libraries whose ABI changes with each
 new upstream Xen release, which include ones which embed
 knowledge of hypervisor-version-specific hypercall ABIs.
Multi-Arch: same

Package: libxencall1t64
Provides: ${t64:Provides}
Replaces: libxencall1
Breaks: libxencall1 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime library - libxencall
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxendevicemodel1t64
Provides: ${t64:Provides}
Replaces: libxendevicemodel1
Breaks: libxendevicemodel1 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxendevicemodel
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenevtchn1t64
Provides: ${t64:Provides}
Replaces: libxenevtchn1
Breaks: libxenevtchn1 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxenevtchn
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenforeignmemory1t64
Provides: ${t64:Provides}
Replaces: libxenforeignmemory1
Breaks: libxenforeignmemory1 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxenforeignmemory
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxengnttab1t64
Provides: ${t64:Provides}
Replaces: libxengnttab1
Breaks: libxengnttab1 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxengnttab
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenstore4t64
Provides: ${t64:Provides}
Replaces: libxenstore4
Breaks: libxenstore4 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxenstore
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxentoolcore1t64
Provides: ${t64:Provides}
Replaces: libxentoolcore1
Breaks: libxentoolcore1 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxentoolcore
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxentoollog1t64
Provides: ${t64:Provides}
Replaces: libxentoollog1
Breaks: libxentoollog1 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxentoollog
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenhypfs1t64
Provides: ${t64:Provides}
Replaces: libxenhypfs1
Breaks: libxenhypfs1 (<< ${source:Version})
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime library - libxenhypfs

## xen 4.17.5%2B23

=== xen/test/livepatch/Makefile ===
ifeq ($(XEN_TARGET_ARCH),x86_64)
OBJCOPY_MAGIC := -I binary -O elf64-x86-64 -B i386:x86-64
endif
ifeq ($(XEN_TARGET_ARCH),arm64)
OBJCOPY_MAGIC := -I binary -O elf64-littleaarch64 -B aarch64
endif
ifeq ($(XEN_TARGET_ARCH),arm32)
OBJCOPY_MAGIC := -I binary -O elf32-littlearm -B arm
endif

CODE_ADDR=$(shell nm --defined $(1) | grep $(2) | awk '{print "0x"$$1}')
CODE_SZ=$(shell nm --defined -S $(1) | grep $(2) | awk '{ print "0x"$$2}')

CFLAGS-y += -iquote $(obj)

extra-y += xen_hello_world.livepatch
xen_hello_world-objs := xen_hello_world_func.o xen_hello_world.o note.o xen_note.o modinfo.o
$(obj)/xen_hello_world.o: $(obj)/config.h

#
# To compute these values we need the binary files: xen-syms
# and xen_hello_world_func.o to be already compiled.
#
$(obj)/config.h: $(obj)/xen_hello_world_func.o
	(set -e; \
	 echo "#define NEW_CODE_SZ $(call CODE_SZ,$<,xen_hello_world)"; \
	 echo "#define MINOR_VERSION_SZ $(call CODE_SZ,$(objtree)/xen-syms,xen_minor_version)"; \
	 echo "#define MINOR_VERSION_ADDR $(call CODE_ADDR,$(objtree)/xen-syms,xen_minor_version)"; \
	 echo "#define OLD_CODE_SZ $(call CODE_SZ,$(objtree)/xen-syms,xen_extra_version)") > $@

$(obj)/modinfo.o:
	(set -e; \
	 printf "LIVEPATCH_RULEZ\0") > $@.bin
	$(OBJCOPY) $(OBJCOPY_MAGIC) \
		   --rename-section=.data=.modinfo,alloc,load,readonly,data,contents -S $@.bin $@
	rm -f $@.bin

#
# This target is only accessible if CONFIG_LIVEPATCH is defined, which
# depends on $(build_id_linker) being available. Hence we do not
# need any checks.
#
# N.B. The reason we don't use arch/x86/note.o is that it may
# not be built (it is for EFI builds), and that we do not have
# the note.o.bin to muck with (as it gets deleted)
#
$(obj)/note.o: $(objtree)/xen-syms
	$(OBJCOPY) -O binary --only-section=.note.gnu.build-id $< $@.bin
	$(OBJCOPY) $(OBJCOPY_MAGIC) \
		   --rename-section=.data=.livepatch.depends,alloc,load,readonly,data,contents -S $@.bin $@
	rm -f $@.bin

#
# Append .livepatch.xen_depends section
# with Xen build-id derived from xen-syms.
#
$(obj)/xen_note.o: $(objtree)/xen-syms
	$(OBJCOPY) -O binary --only-section=.note.gnu.build-id $< $@.bin
	$(OBJCOPY) $(OBJCOPY_MAGIC) \
		   --rename-section=.data=.livepatch.xen_depends,alloc,load,readonly,data,contents -S $@.bin $@
	rm -f $@.bin

#
# Extract the build-id of the xen_hello_world.livepatch
# (which xen_bye_world will depend on).
#
$(obj)/hello_world_note.o: $(obj)/xen_hello_world.livepatch
	$(OBJCOPY) -O binary --only-section=.note.gnu.build-id $< $@.bin
	$(OBJCOPY) $(OBJCOPY_MAGIC) \
		   --rename-section=.data=.livepatch.depends,alloc,load,readonly,data,contents -S $@.bin $@
	rm -f $@.bin


extra-y += xen_bye_world.livepatch
xen_bye_world-objs := xen_bye_world_func.o xen_bye_world.o hello_world_note.o xen_note.o
$(obj)/xen_bye_world.o: $(obj)/config.h


extra-y += xen_replace_world.livepatch
xen_replace_world-objs := xen_replace_world_func.o xen_replace_world.o note.o xen_note.o
$(obj)/xen_replace_world.o: $(obj)/config.h


extra-y += xen_nop.livepatch
xen_nop-objs := xen_nop.o note.o xen_note.o
$(obj)/xen_nop.o: $(obj)/config.h

# This one always fails upon upload, because it deliberately
# does not have a .livepatch.xen_depends (xen_note.o) section.
extra-y += xen_no_xen_buildid.livepatch
xen_no_xen_buildid-objs := xen_nop.o note.o

$(obj)/xen_prepost_hooks.o: $(obj)/config.h

extra-y += xen_prepost_hooks.livepatch
xen_prepost_hooks-objs := xen_prepost_hooks.o xen_hello_world_func.o note.o xen_note.o

$(obj)/xen_prepost_hooks_fail.o: $(obj)/config.h

extra-y += xen_prepost_hooks_fail.livepatch
xen_prepost_hooks_fail-objs := xen_prepost_hooks_fail.o xen_hello_world_func.o note.o xen_note.o

$(obj)/xen_action_hooks.o: $(obj)/config.h

extra-y += xen_action_hooks.livepatch
xen_action_hooks-objs := xen_action_hooks.o xen_hello_world_func.o note.o xen_note.o

$(obj)/xen_action_hooks_nofunc.o: $(obj)/config.h

extra-y += xen_action_hooks_nofunc.livepatch
xen_action_hooks_nofunc-objs := xen_action_hooks_nofunc.o note.o xen_note.o

$(obj)/xen_action_hooks_marker.o: $(obj)/config.h

extra-y += xen_action_hooks_marker.livepatch
xen_action_hooks_marker-objs := xen_action_hooks_marker.o xen_hello_world_func.o note.o xen_note.o

$(obj)/xen_action_hooks_noapply.o: $(obj)/config.h

extra-y += xen_action_hooks_noapply.livepatch
xen_action_hooks_noapply-objs := xen_action_hooks_noapply.o xen_hello_world_func.o note.o xen_note.o

$(obj)/xen_action_hooks_norevert.o: $(obj)/config.h

extra-y += xen_action_hooks_norevert.livepatch
xen_action_hooks_norevert-objs := xen_action_hooks_norevert.o xen_hello_world_func.o note.o xen_note.o

EXPECT_BYTES_COUNT := 8
CODE_GET_EXPECT=$(shell $(OBJDUMP) -d --insn-width=1 $(1) | sed -n -e '/<'$(2)'>:$$/,/^$$/ p' | tail -n +2 | head -n $(EXPECT_BYTES_COUNT) | awk '{$$0=$$2; printf "%s", substr($$0,length-1)}' | sed 's/.\{2\}/0x&,/g' | sed 's/^/{/;s/,$$/}/g')
$(obj)/expect_config.h: $(objtree)/xen-syms
	(set -e; \
	 echo "#define EXPECT_BYTES $(call CODE_GET_EXPECT,$<,xen_extra_version)"; \
         echo "#define EXPECT_BYTES_COUNT $(EXPECT_BYTES_COUNT)") > $@

$(obj)/xen_expectations.o: $(obj)/expect_config.h

extra-y += xen_expectations.livepatch
xen_expectations-objs := xen_expectations.o xen_hello_world_func.o note.o xen_note.o

extra-y += xen_expectations_fail.livepatch
xen_expectations_fail-objs := xen_expectations_fail.o xen_hello_world_func.o note.o xen_note.o


quiet_cmd_livepatch = LD      $@
cmd_livepatch = $(LD) $(XEN_LDFLAGS) $(build_id_linker) -r -o $@ $(real-prereqs)

$(obj)/%.livepatch: FORCE
	$(call if_changed,livepatch)

$(call multi-depend, $(filter %.livepatch,$(extra-y)), .livepatch, -objs)
targets += $(sort $(foreach m,$(basename $(notdir $(filter %.livepatch,$(extra-y)))), \
                    $($(m)-objs)))

LIVEPATCHES := $(filter %.livepatch,$(extra-y))

LIVEPATCH_DEBUG_DIR ?= $(DEBUG_DIR)/xen-livepatch

install: $(addprefix $(obj)/,$(LIVEPATCHES))
	$(INSTALL_DIR) $(DESTDIR)$(LIVEPATCH_DEBUG_DIR)
	$(INSTALL_DATA) $(addprefix $(obj)/,$(LIVEPATCHES)) $(DESTDIR)$(LIVEPATCH_DEBUG_DIR)

uninstall:
	cd $(DESTDIR)$(LIVEPATCH_DEBUG_DIR) && rm -f $(LIVEPATCHES)

clean-files := config.h expect_config.h

=== xen/arch/arm/pci/Makefile ===
obj-y += pci.o
obj-y += pci-access.o
obj-y += pci-host-generic.o
obj-y += pci-host-common.o
obj-y += ecam.o
obj-y += pci-host-zynqmp.o

## xen 4.17.5%2B23-ga4e5191dc0

=== debian/changelog ===
xen (4.17.5+23-ga4e5191dc0-1) bookworm-security; urgency=medium

  * Update to new upstream version 4.17.5+23-ga4e5191dc0, which also contains
    security fixes for the following issues:
    - x86: shadow stack vs exceptions from emulation stubs
      XSA-451 CVE-2023-46841
    - x86: Register File Data Sampling
      XSA-452 CVE-2023-28746
    - GhostRace: Speculative Race Conditions
      XSA-453 CVE-2024-2193
    - x86 HVM hypercalls may trigger Xen bug check
      XSA-454 CVE-2023-46842
    - x86: Incorrect logic for BTC/SRSO mitigations
      XSA-455 CVE-2024-31142
    - x86: Native Branch History Injection
      XSA-456 CVE-2024-2201
    - double unlock in x86 guest IRQ handling
      XSA-458 CVE-2024-31143
    - error handling in x86 IOMMU identity mapping
      XSA-460 CVE-2024-31145
    - PCI device pass-through with shared resources
      XSA-461 CVE-2024-31146
    - x86: Deadlock in vlapic_error()
      XSA-462 CVE-2024-45817
    - Deadlock in x86 HVM standard VGA handling
      XSA-463 CVE-2024-45818
    - libxl leaks data to PVH guests via ACPI tables
      XSA-464 CVE-2024-45819
  * Note that the following XSA are not listed, because...
    - XSA-457 and XSA-465 have patches for the Linux kernel.
    - XSA-459 is within Xapi which is not shipped by this package.
    - XSA-466 contains a documentation update that was only applied to the
      current development version of Xen

 -- Hans van Kranenburg <hans@knorrie.org>  Fri, 20 Dec 2024 18:46:37 +0100
